SystemOrganization addCategory: #ConfigurationOfWidgets!

Object subclass: #ConfigurationOfWidgets
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfWidgets'!

!ConfigurationOfWidgets class methodsFor: 'development support' stamp: 'DaleHenrichs 12/17/2010 10:23'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfWidgets class methodsFor: 'private' stamp: 'DaleHenrichs 11/2/2010 16:51'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfWidgets class methodsFor: 'private' stamp: 'DaleHenrichs 12/6/2010 13:34'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfWidgets class methodsFor: 'private' stamp: 'DaleHenrichs 11/4/2010 10:23'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfWidgets class methodsFor: 'metacello tool support' stamp: 'DaleHenrichs 11/2/2010 14:58'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfWidgets class methodsFor: 'loading' stamp: 'DaleHenrichs 11/29/2010 15:00'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfWidgets class methodsFor: 'loading' stamp: 'DaleHenrichs 11/29/2010 15:00'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfWidgets class methodsFor: 'accessing' stamp: 'dkh 10/13/2009 10:36'!
project

	^self new project! !

!ConfigurationOfWidgets class methodsFor: 'development support' stamp: 'DaleHenrichs 1/13/2011 15:37'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfWidgets methodsFor: 'baselines' stamp: 'mt 12/4/2010 10:21:04.916'!
baseline100: spec 
	<version: '1.0-baseline'>
        
	spec for: #common do: [
      	spec blessing: #baseline.
      	spec repository: 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/SwaUtilities'.
					
		spec project: 'Signals' with: [
			spec
				className: 'ConfigurationOfSignals';
				repository: 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/MetacelloRepository'].

		spec project: 'Animations' with: [
			spec
				className: 'ConfigurationOfAnimations';
				repository: 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/MetacelloRepository'].
			
		spec project: 'SwaUtil' with: [
			spec
				className: 'ConfigurationOfSwaUtil';
				repository: 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/MetacelloRepository'].
		
		spec
			package: 'Icons';
			package: 'Widgets' with: [spec requires: #('Animations' 'Signals' 'SwaUtil')].

		spec group: 'default' with: #('Widgets').
		spec group: 'full' with: #('Widgets' 'Icons')].! !

!ConfigurationOfWidgets methodsFor: 'baselines' stamp: 'mt 4/27/2011 15:17:38.219'!
baseline110: spec 
	<version: '1.1-baseline'>
        
	spec for: #common do: [
      	spec blessing: #baseline.
      	spec repository: 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/SwaUtilities'.
					
		spec project: 'Signals' with: [
			spec
				className: 'ConfigurationOfSignals';
				repository: 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/MetacelloRepository'].

		spec project: 'Animations' with: [
			spec
				className: 'ConfigurationOfAnimations';
				repository: 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/MetacelloRepository'].

		spec package: 'VB-Regex' with: [spec repository: 'http://www.squeaksource.com/Regex'].
					
		spec
			package: 'Icons';
			package: 'Widgets' with: [spec
				requires: #('Animations' 'Signals' 'VB-Regex');
				postLoadDoIt: #postLoad].

		spec group: 'default' with: #('Icons' 'Widgets').
		spec group: 'full' with: #('Icons' 'Widgets')].! !

!ConfigurationOfWidgets methodsFor: 'symbolic versions' stamp: 'mt 2/5/2011 17:52:07.717'!
development: spec 
	<symbolicVersion: #development>
	
	spec for: #'common' version: '1.1'.
! !

!ConfigurationOfWidgets methodsFor: 'postload' stamp: 'mt 5/1/2011 19:53:13.985'!
postLoad
	
	"Initialize shortcuts."
	UiTextEditor initialize.! !

!ConfigurationOfWidgets methodsFor: 'accessing' stamp: 'DaleHenrichs 11/5/2010 13:54'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfWidgets methodsFor: 'symbolic versions' stamp: 'mt 2/5/2011 17:51:58.314'!
stable: spec 
	<symbolicVersion: #stable>
	
	spec for: #'squeak4.1.x' version: '1.0'.
	spec for: #'squeak4.2.x' version: '1.0'.
! !

!ConfigurationOfWidgets methodsFor: 'versions' stamp: 'mt 2/5/2011 17:42:20.834'!
version100: spec

	<version: '1.0' imports: #('1.0-baseline')>
	
	spec for: #common do: [
		spec blessing: #release.
		spec author: 'Marcel Taeumel'.
		
		spec
			project: 'Signals' with: '1.0.1';
			project: 'Animations' with: '1.0';
			project: 'SwaUtil' with: '1.0.1'.
		
		spec
			package: 'Widgets' with: 'Widgets-mt.64';
			package: 'Icons' with: 'Icons-mt.1'].! !

!ConfigurationOfWidgets methodsFor: 'versions' stamp: 'mt 4/27/2011 14:18:22.081'!
version110: spec

	<version: '1.1' imports: #('1.1-baseline')>
	
	spec for: #common do: [
		spec blessing: #development.
		spec author: 'Marcel Taeumel'.
		
		spec
			project: 'Signals' with: '1.0.1';
			project: 'Animations' with: '1.0.2';
			package: 'VB-Regex' with: 'VB-Regex-damienpollet.17'].! !
